/*
 * Microsemi Switchtec(tm) PCIe Management Library
 * Copyright (c) 2017, Microsemi Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 *
 */

#ifndef LIBSWITCHTEC_ERRORS_H
#define LIBSWITCHTEC_ERRORS_H

extern int mrpc_error_cmd;

#define SWITCHTEC_ERRNO_GENERAL_FLAG_BIT (1 << 29)
#define SWITCHTEC_ERRNO_MRPC_FLAG_BIT (1 << 30)
#define ERRNO_MRPC(x) (x & (~SWITCHTEC_ERRNO_MRPC_FLAG_BIT))

enum {
	SWITCHTEC_ERR_LOG_DEF_READ_ERROR = SWITCHTEC_ERRNO_GENERAL_FLAG_BIT,
	SWITCHTEC_ERR_BIN_LOG_READ_ERROR,
	SWITCHTEC_ERR_PARSED_LOG_WRITE_ERROR,
	SWITCHTEC_ERR_LOG_DEF_DATA_INVAL,
	SWITCHTEC_ERR_INVALID_PORT,
	SWITCHTEC_ERR_INVALID_LANE,
};

enum {
	ERR_PHYC_PORT_ARDY_BIND = 0x00000001,
	ERR_LOGC_PORT_ARDY_BIND = 0x00000002,
	ERR_BIND_PRTT_NOT_EXIST = 0x00000003,
	ERR_PHYC_PORT_NOT_EXIST = 0x00000004,
	ERR_PHYC_PORT_DIS = 0x00000005,
	ERR_NO_LOGC_PORT = 0x00000006,
	ERR_BIND_IN_PROGRESS = 0x00000007,
	ERR_BIND_TGT_IS_USP = 0x00000008,
	ERR_BIND_SUBCMD_INVALID = 0x00000009,
	ERR_PHYC_PORT_LINK_ACT = 0x0000000a,
	ERR_LOGC_PORT_NOT_BIND_PHYC_PORT = 0x0000000b,
	ERR_UNBIND_OPT_INVALID = 0x0000000c,
	ERR_BIND_CHECK_FAIL = 0x0000000d,
	ERR_MPRC_UNSUPPORTED = 0x0000004a,
	ERR_XML_VERSION_MISMATCH = 0x0000f011,

	ERR_STACKBIF_STACK_ID_INVALID = 0x54003,
	ERR_STACKBIF_SUBCMD_INVALID = 0x54040,
	ERR_STACKBIF_CODE_INVALID = 0x54042,
	ERR_STACKBIF_PORT_BOUND = 0x54043,

	ERR_REFCLK_SUBCMD_INVALID = 0x54130,
	ERR_REFCLK_STACK_ID_INVALID = 0x54131,

	ERR_NO_AVAIL_MRPC_THREAD = 0x64001,
	ERR_HANDLER_THREAD_NOT_IDLE = 0x64002,
	ERR_NO_BG_THREAD = 0x64003,
	ERR_SUBCMD_INVALID = 0x64004,
	ERR_CMD_INVALID = 0x64005,
	ERR_PARAM_INVALID = 0x64006,
	ERR_BAD_FW_STATE = 0x64007,
	ERR_MRPC_DENIED = 0x64010,
	ERR_MRPC_NO_PREV_DATA = 0x64012,

	ERR_LOOPBACK_PORT_INVALID = 0x2,

	ERR_STACK_INVALID = 0x100001,
	ERR_PORT_INVALID = 0x100002,
	ERR_EVENT_INVALID = 0x100003,
	ERR_RST_RULE_FAILED = 0x100005,
	ERR_UART_NOT_SUPPORTED = 0x100072f1,
	ERR_ACCESS_REFUSED = 0xFFFF0001,
};

#endif
